/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables;


import com.tabajara.base.Indexes;
import com.tabajara.base.Keys;
import com.tabajara.base.Public;
import com.tabajara.base.tables.records.UsuariosRecord;

import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Usuarios extends TableImpl<UsuariosRecord> {

    private static final long serialVersionUID = 778837416;

    /**
     * The reference instance of <code>public.usuarios</code>
     */
    public static final Usuarios USUARIOS = new Usuarios();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<UsuariosRecord> getRecordType() {
        return UsuariosRecord.class;
    }

    /**
     * The column <code>public.usuarios.usuid</code>.
     */
    public final TableField<UsuariosRecord, Integer> USUID = createField("usuid", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaultValue(org.jooq.impl.DSL.field("nextval('usuarios_usuid_seq'::regclass)", org.jooq.impl.SQLDataType.INTEGER)), this, "");

    /**
     * The column <code>public.usuarios.usunome</code>.
     */
    public final TableField<UsuariosRecord, String> USUNOME = createField("usunome", org.jooq.impl.SQLDataType.VARCHAR(20), this, "");

    /**
     * The column <code>public.usuarios.ususenha</code>.
     */
    public final TableField<UsuariosRecord, String> USUSENHA = createField("ususenha", org.jooq.impl.SQLDataType.VARCHAR(20), this, "");

    /**
     * The column <code>public.usuarios.usuativo</code>.
     */
    public final TableField<UsuariosRecord, String> USUATIVO = createField("usuativo", org.jooq.impl.SQLDataType.VARCHAR(20), this, "");

    /**
     * The column <code>public.usuarios.fkfunmatricula</code>.
     */
    public final TableField<UsuariosRecord, String> FKFUNMATRICULA = createField("fkfunmatricula", org.jooq.impl.SQLDataType.VARCHAR(30), this, "");

    /**
     * The column <code>public.usuarios.fkgrpid</code>.
     */
    public final TableField<UsuariosRecord, Integer> FKGRPID = createField("fkgrpid", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * Create a <code>public.usuarios</code> table reference
     */
    public Usuarios() {
        this(DSL.name("usuarios"), null);
    }

    /**
     * Create an aliased <code>public.usuarios</code> table reference
     */
    public Usuarios(String alias) {
        this(DSL.name(alias), USUARIOS);
    }

    /**
     * Create an aliased <code>public.usuarios</code> table reference
     */
    public Usuarios(Name alias) {
        this(alias, USUARIOS);
    }

    private Usuarios(Name alias, Table<UsuariosRecord> aliased) {
        this(alias, aliased, null);
    }

    private Usuarios(Name alias, Table<UsuariosRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, "");
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return Public.PUBLIC;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.USUARIOS_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<UsuariosRecord, Integer> getIdentity() {
        return Keys.IDENTITY_USUARIOS;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<UsuariosRecord> getPrimaryKey() {
        return Keys.USUARIOS_PKEY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<UsuariosRecord>> getKeys() {
        return Arrays.<UniqueKey<UsuariosRecord>>asList(Keys.USUARIOS_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<ForeignKey<UsuariosRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<UsuariosRecord, ?>>asList(Keys.USUARIOS__USUARIOS_FKFUNMATRICULA_FKEY, Keys.USUARIOS__USUARIOS_FKGRPID_FKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Usuarios as(String alias) {
        return new Usuarios(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Usuarios as(Name alias) {
        return new Usuarios(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public Usuarios rename(String name) {
        return new Usuarios(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public Usuarios rename(Name name) {
        return new Usuarios(name, null);
    }
}
